/**
 * This groups all the flags used to control the materials channel.
 */
export declare class MaterialFlags {
    private static _DiffuseTextureEnabled;
    /**
     * Are diffuse textures enabled in the application.
     */
    static get DiffuseTextureEnabled(): boolean;
    static set DiffuseTextureEnabled(value: boolean);
    private static _BaseWeightTextureEnabled;
    /**
     * Is the OpenPBR Base Weight texture enabled in the application.
     */
    static get BaseWeightTextureEnabled(): boolean;
    static set BaseWeightTextureEnabled(value: boolean);
    private static _BaseDiffuseRoughnessTextureEnabled;
    /**
     * Is the OpenPBR Base Diffuse Roughness texture enabled in the application.
     */
    static get BaseDiffuseRoughnessTextureEnabled(): boolean;
    static set BaseDiffuseRoughnessTextureEnabled(value: boolean);
    private static _DetailTextureEnabled;
    /**
     * Are detail textures enabled in the application.
     */
    static get DetailTextureEnabled(): boolean;
    static set DetailTextureEnabled(value: boolean);
    private static _DecalMapEnabled;
    /**
     * Are decal maps enabled in the application.
     */
    static get DecalMapEnabled(): boolean;
    static set DecalMapEnabled(value: boolean);
    private static _AmbientTextureEnabled;
    /**
     * Are ambient textures enabled in the application.
     */
    static get AmbientTextureEnabled(): boolean;
    static set AmbientTextureEnabled(value: boolean);
    private static _OpacityTextureEnabled;
    /**
     * Are opacity textures enabled in the application.
     */
    static get OpacityTextureEnabled(): boolean;
    static set OpacityTextureEnabled(value: boolean);
    private static _ReflectionTextureEnabled;
    /**
     * Are reflection textures enabled in the application.
     */
    static get ReflectionTextureEnabled(): boolean;
    static set ReflectionTextureEnabled(value: boolean);
    private static _EmissiveTextureEnabled;
    /**
     * Are emissive textures enabled in the application.
     */
    static get EmissiveTextureEnabled(): boolean;
    static set EmissiveTextureEnabled(value: boolean);
    private static _SpecularTextureEnabled;
    /**
     * Are specular textures enabled in the application.
     */
    static get SpecularTextureEnabled(): boolean;
    static set SpecularTextureEnabled(value: boolean);
    private static _BumpTextureEnabled;
    /**
     * Are bump textures enabled in the application.
     */
    static get BumpTextureEnabled(): boolean;
    static set BumpTextureEnabled(value: boolean);
    private static _LightmapTextureEnabled;
    /**
     * Are lightmap textures enabled in the application.
     */
    static get LightmapTextureEnabled(): boolean;
    static set LightmapTextureEnabled(value: boolean);
    private static _RefractionTextureEnabled;
    /**
     * Are refraction textures enabled in the application.
     */
    static get RefractionTextureEnabled(): boolean;
    static set RefractionTextureEnabled(value: boolean);
    private static _ColorGradingTextureEnabled;
    /**
     * Are color grading textures enabled in the application.
     */
    static get ColorGradingTextureEnabled(): boolean;
    static set ColorGradingTextureEnabled(value: boolean);
    private static _FresnelEnabled;
    /**
     * Are fresnels enabled in the application.
     */
    static get FresnelEnabled(): boolean;
    static set FresnelEnabled(value: boolean);
    private static _ClearCoatTextureEnabled;
    /**
     * Are clear coat textures enabled in the application.
     */
    static get ClearCoatTextureEnabled(): boolean;
    static set ClearCoatTextureEnabled(value: boolean);
    private static _ClearCoatBumpTextureEnabled;
    /**
     * Are clear coat bump textures enabled in the application.
     */
    static get ClearCoatBumpTextureEnabled(): boolean;
    static set ClearCoatBumpTextureEnabled(value: boolean);
    private static _ClearCoatTintTextureEnabled;
    /**
     * Are clear coat tint textures enabled in the application.
     */
    static get ClearCoatTintTextureEnabled(): boolean;
    static set ClearCoatTintTextureEnabled(value: boolean);
    private static _SheenTextureEnabled;
    /**
     * Are sheen textures enabled in the application.
     */
    static get SheenTextureEnabled(): boolean;
    static set SheenTextureEnabled(value: boolean);
    private static _AnisotropicTextureEnabled;
    /**
     * Are anisotropic textures enabled in the application.
     */
    static get AnisotropicTextureEnabled(): boolean;
    static set AnisotropicTextureEnabled(value: boolean);
    private static _ThicknessTextureEnabled;
    /**
     * Are thickness textures enabled in the application.
     */
    static get ThicknessTextureEnabled(): boolean;
    static set ThicknessTextureEnabled(value: boolean);
    private static _RefractionIntensityTextureEnabled;
    /**
     * Are refraction intensity textures enabled in the application.
     */
    static get RefractionIntensityTextureEnabled(): boolean;
    static set RefractionIntensityTextureEnabled(value: boolean);
    private static _TranslucencyIntensityTextureEnabled;
    /**
     * Are translucency intensity textures enabled in the application.
     */
    static get TranslucencyIntensityTextureEnabled(): boolean;
    static set TranslucencyIntensityTextureEnabled(value: boolean);
    private static _TranslucencyColorTextureEnabled;
    /**
     * Are translucency tint textures enabled in the application.
     */
    static get TranslucencyColorTextureEnabled(): boolean;
    static set TranslucencyColorTextureEnabled(value: boolean);
    private static _IridescenceTextureEnabled;
    /**
     * Are translucency intensity textures enabled in the application.
     */
    static get IridescenceTextureEnabled(): boolean;
    static set IridescenceTextureEnabled(value: boolean);
}
